package com.ruoyi.project.sems.mapper;

import java.util.List;

import com.ruoyi.framework.aspectj.lang.annotation.DataScope;
import com.ruoyi.framework.aspectj.lang.annotation.DataScopePlant;
import com.ruoyi.project.sems.domain.TReportYlgd;
import com.ruoyi.project.sems.domain.TReportYlrq;
import com.ruoyi.project.sems.domain.TSpecdevYlgd;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

/**
 * 压力管道年检报告Mapper接口
 *
 * @author ruoyi
 * @date 2021-09-02
 */
@Component("tReportYlgdMapper")
public interface TReportYlgdMapper {

    /**
     * 插入需要新增的压力管道年检报告
     *
     * @param tSpecdevYlgd 数据源-压力管道在用台账数据
     * @return
     */
    public int insertByTSpecdevYlgd(TSpecdevYlgd tSpecdevYlgd);

    /**
     * 更新已存在的压力管道年检报告
     *
     * @param tSpecdevYlgd 数据源-压力管道在用台账数据
     * @return
     */
    public int updateByTSpecdevYlgd(TSpecdevYlgd tSpecdevYlgd);

    /**
     * 获取压力管道在用台账与压力管道年检数据需要插入的id
     *
     * @return
     */
    public List<Long> queryNeedInsertIds();

    /**
     * 获取压力管道在用台账与压力管道年检数据不一致部分id
     *
     * @return
     */
    public List<Long> queryNeedDeleteIds();

    /**
     * 获取压力管道在用台账与压力管道年检数据需要删除的部分id
     *
     * @return
     */
    public List<Long> queryNeedUpdateIds();

    /**
     * 根据excel导入的数据进行数据更新操作
     * 根据 位号、使用证、注册编号 3个条件去更新
     * @param tReportYlgd excel中获取的数据
     * @return
     */
    public int updateForImport(TReportYlgd tReportYlgd);

    /**
     * 查询压力管道年检报告
     *
     * @param id 压力管道年检报告ID
     * @return 压力管道年检报告
     */
    public TReportYlgd selectTReportYlgdById(Long id);

    /**
     * 查询压力管道年检报告列表
     *
     * @param tReportYlgd 压力管道年检报告
     * @return 压力管道年检报告集合
     */
    @DataScopePlant(deptAlias = "y")
    public List<TReportYlgd> selectTReportYlgdList(TReportYlgd tReportYlgd);

    /**
     * 新增压力管道年检报告
     *
     * @param tReportYlgd 压力管道年检报告
     * @return 结果
     */
    public int insertTReportYlgd(TReportYlgd tReportYlgd);

    /**
     * 修改压力管道年检报告
     *
     * @param tReportYlgd 压力管道年检报告
     * @return 结果
     */
    public int updateTReportYlgd(TReportYlgd tReportYlgd);

    /**
     * 删除压力管道年检报告
     *
     * @param id 压力管道年检报告ID
     * @return 结果
     */
    public int deleteTReportYlgdById(Long id);

    /**
     * 批量删除压力管道年检报告
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteTReportYlgdByIds(Long[] ids);

    int sysnReport(TReportYlgd tReportYlgd);
}
